From a3b9d49dab4d38d0f419cd139d43d3cefc1a8115 Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Mon, 25 Nov 2013 12:39:26 -0500
Subject: [PATCH] Moved cmsbundle into server folder.

The pki-cmsbundle.jar is distributed in pki-server package so the files
have been moved into the base/server folder.
---
 base/common/src/CMakeLists.txt                     | 30 ----------------------
 base/server/CMakeLists.txt                         |  1 +
 base/server/cmsbundle/CMakeLists.txt               |  3 +++
 base/server/cmsbundle/src/CMakeLists.txt           | 30 ++++++++++++++++++++++
 .../cmsbundle}/src/LogMessages.properties          |  0
 .../cmsbundle}/src/UserMessages.properties         |  0
 .../cmsbundle}/src/pki-cmsbundle.mf                |  0
 7 files changed, 34 insertions(+), 30 deletions(-)
 create mode 100644 base/server/cmsbundle/CMakeLists.txt
 create mode 100644 base/server/cmsbundle/src/CMakeLists.txt
 rename base/{common => server/cmsbundle}/src/LogMessages.properties (100%)
 rename base/{common => server/cmsbundle}/src/UserMessages.properties (100%)
 rename base/{common => server/cmsbundle}/src/pki-cmsbundle.mf (100%)

diff --git a/base/common/src/CMakeLists.txt b/base/common/src/CMakeLists.txt
index 8300795eb1d88ee7a72fad0a184e6e1f5e882670..e4f99992198bab76079d13faa4a5db53cbb83dcf 100644
--- a/base/common/src/CMakeLists.txt
+++ b/base/common/src/CMakeLists.txt
@@ -164,33 +164,3 @@ install(
 )
 
 set(PKI_CERTSRV_JAR ${CMAKE_BINARY_DIR}/dist/pki-certsrv.jar CACHE INTERNAL "pki-certsrv jar file")
-
-
-# build pki-cmsbundle
-configure_file(
-    ${CMAKE_CURRENT_SOURCE_DIR}/pki-cmsbundle.mf
-    ${CMAKE_CURRENT_BINARY_DIR}/pki-cmsbundle.mf
-)
-
-jar(pki-cmsbundle-jar
-    CREATE
-        ${CMAKE_BINARY_DIR}/dist/pki-cmsbundle.jar
-    OPTIONS
-        m
-    PARAMS
-        ${CMAKE_CURRENT_BINARY_DIR}/pki-cmsbundle.mf
-    FILES
-        LogMessages.properties
-        UserMessages.properties
-    DEPENDS
-        pki-cmsbundle-jar
-)
-
-install(
-    FILES
-        ${CMAKE_BINARY_DIR}/dist/pki-cmsbundle.jar
-    DESTINATION
-        ${JAVA_JAR_INSTALL_DIR}/pki
-)
-
-set(PKI_CMSBUNDLE_JAR ${CMAKE_BINARY_DIR}/dist/pki-cmsbundle.jar INTERNAL "pki-cmsbundle jar file")
diff --git a/base/server/CMakeLists.txt b/base/server/CMakeLists.txt
index 5250ff3a67882ee16acaa452982f8c6338ea4308..01a194a3dc894dcc831393623f84a725c5c0fafd 100644
--- a/base/server/CMakeLists.txt
+++ b/base/server/CMakeLists.txt
@@ -142,5 +142,6 @@ install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${VAR_INSTALL_DIR}/run/pki)")
 
 add_subdirectory(tomcat)
 add_subdirectory(cms)
+add_subdirectory(cmsbundle)
 add_subdirectory(cmscore)
 add_subdirectory(test)
diff --git a/base/server/cmsbundle/CMakeLists.txt b/base/server/cmsbundle/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..b715bc80e394f46d3a13106d06e82a2f7e6199e4
--- /dev/null
+++ b/base/server/cmsbundle/CMakeLists.txt
@@ -0,0 +1,3 @@
+project(cmsbundle)
+
+add_subdirectory(src)
diff --git a/base/server/cmsbundle/src/CMakeLists.txt b/base/server/cmsbundle/src/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..cc9a72aed85473c202e3e5e3a9d085c2da5b05a5
--- /dev/null
+++ b/base/server/cmsbundle/src/CMakeLists.txt
@@ -0,0 +1,30 @@
+project(pki-cmsbundle_java NONE)
+
+# build pki-cmsbundle
+configure_file(
+    ${CMAKE_CURRENT_SOURCE_DIR}/pki-cmsbundle.mf
+    ${CMAKE_CURRENT_BINARY_DIR}/pki-cmsbundle.mf
+)
+
+jar(pki-cmsbundle-jar
+    CREATE
+        ${CMAKE_BINARY_DIR}/dist/pki-cmsbundle.jar
+    OPTIONS
+        m
+    PARAMS
+        ${CMAKE_CURRENT_BINARY_DIR}/pki-cmsbundle.mf
+    FILES
+        LogMessages.properties
+        UserMessages.properties
+    DEPENDS
+        pki-cmsbundle-jar
+)
+
+install(
+    FILES
+        ${CMAKE_BINARY_DIR}/dist/pki-cmsbundle.jar
+    DESTINATION
+        ${JAVA_JAR_INSTALL_DIR}/pki
+)
+
+set(PKI_CMSBUNDLE_JAR ${CMAKE_BINARY_DIR}/dist/pki-cmsbundle.jar INTERNAL "pki-cmsbundle jar file")
diff --git a/base/common/src/LogMessages.properties b/base/server/cmsbundle/src/LogMessages.properties
similarity index 100%
rename from base/common/src/LogMessages.properties
rename to base/server/cmsbundle/src/LogMessages.properties
diff --git a/base/common/src/UserMessages.properties b/base/server/cmsbundle/src/UserMessages.properties
similarity index 100%
rename from base/common/src/UserMessages.properties
rename to base/server/cmsbundle/src/UserMessages.properties
diff --git a/base/common/src/pki-cmsbundle.mf b/base/server/cmsbundle/src/pki-cmsbundle.mf
similarity index 100%
rename from base/common/src/pki-cmsbundle.mf
rename to base/server/cmsbundle/src/pki-cmsbundle.mf
-- 
1.8.4.2